lxc.sh 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484
  1. #!/usr/bin/env bash
  2. # -*- coding: utf-8; mode: sh indent-tabs-mode: nil -*-
  3. # SPDX-License-Identifier: AGPL-3.0-or-later
  4. # shellcheck source=utils/lib.sh
  5. source "$(dirname "${BASH_SOURCE[0]}")/lib.sh"
  6. source_dot_config
  7. # load environment of the LXC suite
  8. LXC_ENV="${LXC_ENV:-${REPO_ROOT}/utils/lxc-searx.env}"
  9. source "$LXC_ENV"
  10. lxc_set_suite_env
  11. # ----------------------------------------------------------------------------
  12. # config
  13. # ----------------------------------------------------------------------------
  14. #
  15. # read also:
  16. # - https://lxd.readthedocs.io/en/latest/
  17. LXC_HOST_PREFIX="${LXC_HOST_PREFIX:-test}"
  18. # where all folders from HOST are mounted
  19. LXC_SHARE_FOLDER="/share"
  20. LXC_REPO_ROOT="${LXC_SHARE_FOLDER}/$(basename "${REPO_ROOT}")"
  21. ubu1604_boilerplate="
  22. export DEBIAN_FRONTEND=noninteractive
  23. apt-get update -y
  24. apt-get upgrade -y
  25. apt-get install -y git curl wget
  26. "
  27. ubu1804_boilerplate="$ubu1604_boilerplate"
  28. ubu1904_boilerplate="$ubu1804_boilerplate"
  29. ubu1910_boilerplate="$ubu1904_boilerplate"
  30. # shellcheck disable=SC2034
  31. ubu2004_boilerplate="
  32. $ubu1910_boilerplate
  33. echo 'Set disable_coredump false' >> /etc/sudo.conf
  34. "
  35. # shellcheck disable=SC2034
  36. archlinux_boilerplate="
  37. pacman -Syu --noconfirm
  38. pacman -S --noconfirm git curl wget sudo
  39. echo 'Set disable_coredump false' >> /etc/sudo.conf
  40. "
  41. # shellcheck disable=SC2034
  42. fedora31_boilerplate="
  43. dnf update -y
  44. dnf install -y git curl wget hostname
  45. echo 'Set disable_coredump false' >> /etc/sudo.conf
  46. "
  47. REMOTE_IMAGES=()
  48. CONTAINERS=()
  49. LOCAL_IMAGES=()
  50. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  51. REMOTE_IMAGES=("${REMOTE_IMAGES[@]}" "${LXC_SUITE[i]}")
  52. CONTAINERS=("${CONTAINERS[@]}" "${LXC_HOST_PREFIX}-${LXC_SUITE[i+1]}")
  53. LOCAL_IMAGES=("${LOCAL_IMAGES[@]}" "${LXC_SUITE[i+1]}")
  54. done
  55. HOST_USER="${SUDO_USER:-$USER}"
  56. HOST_USER_ID=$(id -u "${HOST_USER}")
  57. HOST_GROUP_ID=$(id -g "${HOST_USER}")
  58. # ----------------------------------------------------------------------------
  59. usage() {
  60. # ----------------------------------------------------------------------------
  61. _cmd="$(basename "$0")"
  62. cat <<EOF
  63. usage::
  64. $_cmd build [containers]
  65. $_cmd copy [images]
  66. $_cmd remove [containers|<name>|images]
  67. $_cmd [start|stop] [containers|<name>]
  68. $_cmd show [info|config|suite|images]
  69. $_cmd cmd [--|<name>] '...'
  70. $_cmd install [suite|base|buildhost]
  71. build
  72. :containers: build, launch and 'install basic' packages on 'containers'
  73. copy:
  74. :images: copy remote images of the suite into local storage
  75. remove
  76. :containers: delete all 'containers' or only <container-name>
  77. :images: delete local images of the suite
  78. start/stop
  79. :containers: start/stop all 'containers' from the suite
  80. :<name>: start/stop conatiner <name> from suite
  81. show
  82. :info: show info of all the containers from LXC suite
  83. :config: show config of all the containers from the LXC suite
  84. :suite: show services of all the containers from the LXC suite
  85. :images: show information of local images
  86. cmd
  87. use single qoutes to evaluate in container's bash, e.g. 'echo $(hostname)'
  88. -- run command '...' in all containers of the LXC suite
  89. :<name>: run command '...' in container <name>
  90. install
  91. :suite: install LXC suite; ${LXC_SUITE_INSTALL_INFO}
  92. :base: prepare LXC; install basic packages
  93. :buildhost: prepare LXC; install buildhost packages
  94. EOF
  95. usage_images
  96. echo
  97. usage_containers
  98. echo
  99. [ -n "${1+x}" ] && err_msg "$1"
  100. }
  101. usage_containers() {
  102. cat <<EOF
  103. LXC suite containers:
  104. $(echo " ${CONTAINERS[*]}" | $FMT)
  105. EOF
  106. [ -n "${1+x}" ] && err_msg "$1"
  107. }
  108. usage_images() {
  109. cat <<EOF
  110. LXC suite images:
  111. $(echo " ${LOCAL_IMAGES[*]}" | $FMT)
  112. EOF
  113. }
  114. lxd_info() {
  115. cat <<EOF
  116. LXD is needed, to install run::
  117. snap install lxd
  118. lxd init --auto
  119. EOF
  120. }
  121. main() {
  122. local exit_val
  123. local _usage="unknown or missing $1 command $2"
  124. # don't check prerequisite when in recursion
  125. if [[ ! $1 == __* ]]; then
  126. ! required_commands lxc && lxd_info && exit 42
  127. [[ -z $LXC_SUITE ]] && err_msg "missing LXC_SUITE" && exit 42
  128. fi
  129. case $1 in
  130. --source-only) ;;
  131. -h|--help) usage; exit 0;;
  132. build)
  133. sudo_or_exit
  134. case $2 in
  135. ''|containers) build_instances ;;
  136. *) usage "$_usage"; exit 42;;
  137. esac
  138. ;;
  139. copy)
  140. case $2 in
  141. ''|images) lxc_copy_images_localy;;
  142. *) usage "$_usage"; exit 42;;
  143. esac
  144. ;;
  145. remove)
  146. sudo_or_exit
  147. case $2 in
  148. ''|containers) remove_instances ;;
  149. images) lxc_delete_images_localy ;;
  150. ${LXC_HOST_PREFIX}-*)
  151. ! lxc_exists "$2" && usage_containers "unknown container: $2" && exit 42
  152. if ask_yn "Do you really want to delete conatiner $2"; then
  153. lxc_delete_container "$2"
  154. fi
  155. ;;
  156. *) usage "uknown or missing container <name> $2"; exit 42;;
  157. esac
  158. ;;
  159. start|stop)
  160. sudo_or_exit
  161. case $2 in
  162. ''|containers) lxc_cmd "$1" ;;
  163. ${LXC_HOST_PREFIX}-*)
  164. ! lxc_exists "$2" && usage_containers "unknown container: $2" && exit 42
  165. info_msg "lxc $1 $2"
  166. lxc "$1" "$2" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  167. ;;
  168. *) usage "uknown or missing container <name> $2"; exit 42;;
  169. esac
  170. ;;
  171. show)
  172. sudo_or_exit
  173. case $2 in
  174. suite) show_suite ;;
  175. images) show_images ;;
  176. config)
  177. rst_title "container configurations"
  178. echo
  179. lxc list "$LXC_HOST_PREFIX-"
  180. echo
  181. lxc_cmd config show
  182. ;;
  183. info)
  184. rst_title "container info"
  185. echo
  186. lxc_cmd info
  187. ;;
  188. *) usage "$_usage"; exit 42;;
  189. esac
  190. ;;
  191. __show)
  192. # wrapped show commands, called once in each container
  193. case $2 in
  194. suite) lxc_suite_info ;;
  195. esac
  196. ;;
  197. cmd)
  198. sudo_or_exit
  199. shift
  200. case $1 in
  201. --) shift; lxc_exec "$@" ;;
  202. ${LXC_HOST_PREFIX}-*)
  203. ! lxc_exists "$1" && usage_containers "unknown container: $1" && exit 42
  204. local name=$1
  205. shift
  206. lxc_exec_cmd "${name}" "$@"
  207. ;;
  208. *) usage "uknown or missing container <name> $1"; exit 42;;
  209. esac
  210. ;;
  211. install)
  212. sudo_or_exit
  213. case $2 in
  214. suite|base|buildhost)
  215. lxc_exec "${LXC_REPO_ROOT}/utils/lxc.sh" __install "$2"
  216. ;;
  217. *) usage "$_usage"; exit 42 ;;
  218. esac
  219. ;;
  220. __install)
  221. # wrapped install commands, called once in each container
  222. # shellcheck disable=SC2119
  223. case $2 in
  224. suite) lxc_suite_install ;;
  225. base) FORCE_TIMEOUT=0 lxc_install_base_packages ;;
  226. buildhost) lxc_suite_prepare_buildhost ;;
  227. esac
  228. ;;
  229. doc)
  230. echo
  231. echo ".. generic utils/lxc.sh documentation"
  232. ;;
  233. -*) usage "unknown option $1"; exit 42;;
  234. *) usage "unknown or missing command $1"; exit 42;;
  235. esac
  236. }
  237. build_instances() {
  238. rst_title "Build LXC instances"
  239. lxc_copy_images_localy
  240. echo
  241. rst_title "build containers" section
  242. echo
  243. lxc_init_containers
  244. lxc_config_containers
  245. lxc_boilerplate_containers
  246. echo
  247. lxc_exec "${LXC_REPO_ROOT}/utils/lxc.sh" __install base
  248. echo
  249. lxc list "$LXC_HOST_PREFIX"
  250. }
  251. remove_instances() {
  252. rst_title "Remove LXC instances"
  253. rst_para "existing containers matching ${_BGreen}$LXC_HOST_PREFIX-*${_creset}"
  254. echo
  255. lxc list "$LXC_HOST_PREFIX-"
  256. echo -en "\\n${_BRed}LXC containers to delete::${_creset}\\n\\n ${CONTAINERS[*]}\\n" | $FMT
  257. if ask_yn "Do you really want to delete these conatiners"; then
  258. for i in "${CONTAINERS[@]}"; do
  259. lxc_delete_container "$i"
  260. done
  261. fi
  262. echo
  263. lxc list "$LXC_HOST_PREFIX-"
  264. }
  265. # images
  266. # ------
  267. lxc_copy_images_localy() {
  268. rst_title "copy images" section
  269. echo
  270. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  271. if lxc_image_exists "local:${LXC_SUITE[i+1]}"; then
  272. info_msg "image ${LXC_SUITE[i]} already copied --> ${LXC_SUITE[i+1]}"
  273. else
  274. info_msg "copy image locally ${LXC_SUITE[i]} --> ${LXC_SUITE[i+1]}"
  275. lxc image copy "${LXC_SUITE[i]}" local: \
  276. --alias "${LXC_SUITE[i+1]}" | prefix_stdout
  277. fi
  278. done
  279. # lxc image list local: && wait_key
  280. }
  281. lxc_delete_images_localy() {
  282. rst_title "Delete LXC images"
  283. rst_para "local existing images"
  284. echo
  285. lxc image list local:
  286. echo -en "\\n${_BRed}LXC images to delete::${_creset}\\n\\n ${LOCAL_IMAGES[*]}\\n"
  287. if ask_yn "Do you really want to delete these images"; then
  288. for i in "${LOCAL_IMAGES[@]}"; do
  289. lxc_delete_local_image "$i"
  290. done
  291. fi
  292. echo
  293. lxc image list local:
  294. }
  295. show_images(){
  296. rst_title "local images"
  297. echo
  298. lxc image list local:
  299. echo -en "\\n${_Green}LXC suite images::${_creset}\\n\\n ${LOCAL_IMAGES[*]}\\n"
  300. wait_key
  301. for i in "${LOCAL_IMAGES[@]}"; do
  302. if lxc_image_exists "$i"; then
  303. info_msg "lxc image info ${_BBlue}${i}${_creset}"
  304. lxc image info "$i" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  305. else
  306. warn_msg "image ${_BBlue}$i${_creset} does not yet exists"
  307. fi
  308. done
  309. }
  310. # container
  311. # ---------
  312. show_suite(){
  313. rst_title "LXC suite ($LXC_HOST_PREFIX-*)"
  314. echo
  315. lxc list "$LXC_HOST_PREFIX-"
  316. echo
  317. for i in "${CONTAINERS[@]}"; do
  318. if ! lxc_exists "$i"; then
  319. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  320. else
  321. lxc exec -t "${i}" -- "${LXC_REPO_ROOT}/utils/lxc.sh" __show suite \
  322. | prefix_stdout "[${_BBlue}${i}${_creset}] "
  323. echo
  324. fi
  325. done
  326. }
  327. lxc_cmd() {
  328. for i in "${CONTAINERS[@]}"; do
  329. if ! lxc_exists "$i"; then
  330. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  331. else
  332. info_msg "lxc $* $i"
  333. lxc "$@" "$i" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  334. echo
  335. fi
  336. done
  337. }
  338. lxc_exec_cmd() {
  339. local name="$1"
  340. shift
  341. exit_val=
  342. info_msg "[${_BBlue}${name}${_creset}] ${_BGreen}${*}${_creset}"
  343. lxc exec -t --cwd "${LXC_REPO_ROOT}" "${name}" -- bash -c "$*"
  344. exit_val=$?
  345. if [[ $exit_val -ne 0 ]]; then
  346. warn_msg "[${_BBlue}${name}${_creset}] exit code (${_BRed}${exit_val}${_creset}) from ${_BGreen}${*}${_creset}"
  347. else
  348. info_msg "[${_BBlue}${name}${_creset}] exit code (${exit_val}) from ${_BGreen}${*}${_creset}"
  349. fi
  350. }
  351. lxc_exec() {
  352. for i in "${CONTAINERS[@]}"; do
  353. if ! lxc_exists "$i"; then
  354. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  355. else
  356. lxc_exec_cmd "${i}" "$@" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  357. fi
  358. done
  359. }
  360. lxc_init_containers() {
  361. local image_name
  362. local container_name
  363. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  364. image_name="${LXC_SUITE[i+1]}"
  365. container_name="${LXC_HOST_PREFIX}-${image_name}"
  366. if lxc info "${container_name}" &>/dev/null; then
  367. info_msg "container '${container_name}' already exists"
  368. else
  369. info_msg "create conatiner instance: ${container_name}"
  370. lxc init "local:${image_name}" "${container_name}"
  371. fi
  372. done
  373. }
  374. lxc_config_containers() {
  375. for i in "${CONTAINERS[@]}"; do
  376. info_msg "[${_BBlue}${i}${_creset}] configure container ..."
  377. info_msg "[${_BBlue}${i}${_creset}] map uid/gid from host to container"
  378. # https://lxd.readthedocs.io/en/latest/userns-idmap/#custom-idmaps
  379. echo -e -n "uid $HOST_USER_ID 0\\ngid $HOST_GROUP_ID 0"\
  380. | lxc config set "$i" raw.idmap -
  381. info_msg "[${_BBlue}${i}${_creset}] share ${REPO_ROOT} (repo_share) from HOST into container"
  382. # https://lxd.readthedocs.io/en/latest/instances/#type-disk
  383. lxc config device add "$i" repo_share disk \
  384. source="${REPO_ROOT}" \
  385. path="${LXC_REPO_ROOT}" &>/dev/null
  386. # lxc config show "$i" && wait_key
  387. done
  388. }
  389. lxc_boilerplate_containers() {
  390. local image_name
  391. local container_name
  392. local boilerplate_script
  393. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  394. image_name="${LXC_SUITE[i+1]}"
  395. container_name="${LXC_HOST_PREFIX}-${image_name}"
  396. boilerplate_script="${image_name}_boilerplate"
  397. boilerplate_script="${!boilerplate_script}"
  398. info_msg "[${_BBlue}${container_name}${_creset}] init .."
  399. if lxc start -q "${container_name}" &>/dev/null; then
  400. sleep 5 # guest needs some time to come up and get an IP
  401. fi
  402. lxc_init_container "${container_name}"
  403. info_msg "[${_BBlue}${container_name}${_creset}] install /.lxcenv.mk .."
  404. cat <<EOF | lxc exec "${container_name}" -- bash | prefix_stdout "[${_BBlue}${container_name}${_creset}] "
  405. rm -f "/.lxcenv.mk"
  406. ln -s "${LXC_REPO_ROOT}/utils/makefile.lxc" "/.lxcenv.mk"
  407. ls -l "/.lxcenv.mk"
  408. EOF
  409. info_msg "[${_BBlue}${container_name}${_creset}] install boilerplate .."
  410. if lxc start -q "${container_name}" &>/dev/null; then
  411. sleep 5 # guest needs some time to come up and get an IP
  412. fi
  413. if [[ -n "${boilerplate_script}" ]]; then
  414. echo "${boilerplate_script}" \
  415. | lxc exec "${container_name}" -- bash \
  416. | prefix_stdout "[${_BBlue}${container_name}${_creset}] "
  417. else
  418. err_msg "[${_BBlue}${container_name}${_creset}] no boilerplate for image '${image_name}'"
  419. fi
  420. done
  421. }
  422. # ----------------------------------------------------------------------------
  423. main "$@"
  424. # ----------------------------------------------------------------------------